---
title: Firefox 67 for developers
slug: Mozilla/Firefox/Releases/67
tags:
  - '67'
  - Firefox
  - Mozilla
  - Release
---
<p>{{FirefoxSidebar}}</p>

<p class="summary">This article provides information about the changes in Firefox 67 that will affect developers. Firefox 67 was released on May 21, 2019.</p>

<h2 id="Changes_for_web_developers">Changes for web developers</h2>

<h3 id="Developer_tools">Developer tools</h3>

<ul>
 <li>Debugger updates:
  <ul>
   <li><a href="/en-US/docs/Tools/Debugger/How_to/Set_a_breakpoint">Column breakpoints</a> allow you to select the specific point (or column) in a line of code where you want the debugger to break ({{bug(1528417)}}).</li>
   <li><a href="/en-US/docs/Tools/Debugger/Set_a_log_point">Log points</a> allow you to log specific information to the console during code execution without pausing execution and without the need to change the code.</li>
   <li>The <a href="/en-US/docs/Tools/Debugger/Using_the_Debugger_map_scopes_feature">map scopes feature</a> allows you to view the variables from the original source.</li>
   <li>You can <a href="/en-US/docs/Tools/Debugger/Debug_worker_threads">debug worker</a> threads directly in the debugger.</li>
  </ul>
 </li>
 <li><a href="/en-US/docs/Tools/Web_Console">Web Console</a> updates:
  <ul>
   <li>Navigate details in the console using the keyboard ({{bug(1424159)}}).</li>
   <li>Cmd + K will now clear the console of its contents on macOS ({{bug(1532939)}}).</li>
   <li>When the user clears the console, the error messages cache is cleared as well ({{bug(717611)}}).</li>
   <li>The user can import existing modules into the current page using import ({{bug(1517546)}}).</li>
   <li>A new context menu item allows the user to use the <strong>Copy Link Location</strong> command ({{bug(1457111)}}).</li>
   <li>Clicking a link in the Console causes the same behavior that it would in a content window ({{bug(1466040)}}).</li>
   <li>Clicking the source link for a code file in the Console panel navigates to the Debugger if debugger knows the file ({{bug(1447244)}}).</li>
   <li>When the user has filtered the contents of the console, an icon will be added to the filter text box to clear the filter ({{bug(1525821)}}).</li>
  </ul>
 </li>
 <li><a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a> enhancements:
  <ul>
   <li>The <a href="/en-US/docs/Tools/Network_Monitor/request_details#Headers">Header</a> panel of the Network monitor will now display a notification for resources belonging to a known tracker ({{bug(1485416)}}).</li>
   <li>In the Network monitor <a href="/en-US/docs/Tools/Network_Monitor/request_list#Network_request_columns">request columns</a>, you can control the visible columns and column sorting. The context menu now includes a command to restore the list sort parameters to the default ({{bug(1454962)}}).</li>
   <li>You can change the <a href="/en-US/docs/Tools/Network_Monitor/request_list#Network_request_columns">width of the columns</a> in the Network Monitor to suit your workflow ({{bug(1358414)}}).</li>
  </ul>
 </li>
</ul>

<h4 id="Removals">Removals</h4>

<ul>
 <li>The following Developer Tools panels have been removed (see <a href="/en-US/docs/Tools/Deprecated_tools">Deprecated tools</a> for details):

  <ul>
   <li>Canvas debugger ({{bug(1403938)}}).</li>
   <li>Shader editor ({{bug(1342237)}}).</li>
   <li>WebAudio editor ({{bug(1403944)}}).</li>
  </ul>
 </li>
 <li>The following Developer Tools have been deprecated (see <a href="/en-US/docs/Tools/Deprecated_tools">Deprecated tools</a> for details):
  <ul>
   <li>WebIDE ({{bug(1539462)}}).</li>
   <li>Connect... page ({{bug(1539462)}}).</li>
  </ul>
 </li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>{{htmlelement("input")}} elements with <code><a href="/en-US/docs/Web/HTML/Attributes/autocomplete">autocomplete</a>="new-password"</code> set on them will no longer have previously saved passwords auto-filled ({{bug(1119063)}}).</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>The {{cssxref("revert")}} keyword has been implemented ({{bug(1215878)}}).</li>
 <li>The <code>break-word</code> value of the {{cssxref("word-break")}} property is now supported ({{bug(1296042)}}).</li>
 <li>The <code><a href="/en-US/docs/Web/CSS/@media/prefers-color-scheme">prefers-color-scheme</a></code> media feature is now supported ({{bug(1494034)}}).</li>
 <li>Custom {{cssxref("cursor")}}s of greater than 32px in size are now disallowed, to mitigate potential malware uses of large cursors ({{bug(1445844)}}).</li>
</ul>

<h4 id="Removals_2">Removals</h4>

<ul>
 <li>Use of the proprietary {{cssxref("-moz-binding")}} property is now restricted to chrome and UA-stylesheets ({{bug(1523712)}}).</li>
</ul>

<h3 id="SVG">SVG</h3>

<p><em>No changes.</em></p>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>{{jsxref("String.prototype.matchAll")}} has been implemented and enabled by default ({{bug(1435829)}}, {{bug(1531830)}}).</li>
 <li>Support for the dynamic module {{jsxref("Statements/import", "import()", "#Dynamic_Imports")}} proposal is now available by default ({{bug(1517546)}}).</li>
 <li>The <a href="/en-US/docs/Web/JavaScript/Reference/Lexical_grammar#Hashbang_comments">hashbang grammar</a> proposal is now implemented ({{bug(1519097)}}).</li>
</ul>

<h3 id="APIs">APIs</h3>

<h4 id="DOM">DOM</h4>

<ul>
 <li>The default value for {{domxref("Response.statusText")}} is now <code>""</code> ({{bug(1508996)}}).</li>
 <li>User gestures are now preserved for rejected calls to {{domxref("Document.requestStorageAccess")}}, as well as fulfilled calls ({{bug(1522912)}}).</li>
</ul>

<h4 id="DOM_events">DOM events</h4>

<ul>
 <li>CSS transition ({{bug(1530239)}}) and animation ({{bug(1531605)}}) events now fire on disabled (e.g. form) elements.</li>
 <li>{{domxref("InputEvent.data")}} and {{domxref("InputEvent.dataTransfer")}} have been implemented ({{bug("998941")}}).</li>
 <li>The <code>insertFromPasteAsQuotation</code> {{domxref("InputEvent.inputType")}} value is now supported ({{bug(1532527)}}).</li>
</ul>

<h4 id="WorkersService_workers">Workers/Service workers</h4>

<ul>
 <li>Strict MIME type checks are now enforced on scripts imported by {{domxref("WorkerGlobalScope.importScripts()")}} ({{bug(1514680)}}).</li>
</ul>

<h4 id="Media_Web_Audio_and_WebRTC">Media, Web Audio, and WebRTC</h4>

<ul>
 <li>The <a href="/en-US/docs/Web/Media/Formats/Video_codecs#AV1">AV1 video codec</a> is now supported on Linux.</li>
 <li><a href="https://code.videolan.org/videolan/dav1d">dav1d</a> is now the default media decoder for <a href="https://aomediacodec.github.io/av1-spec/av1-spec.pdf">AV1</a> (see for example {{bug(1533742)}} and {{bug(1535038)}}).</li>
 <li>Calling {{domxref("RTCPeerConnection.addTrack()")}} without specifying any streams to which to add the new track now works as expected: it adds a streamless track to the connection. Each peer is responsible for managing the association between the track and any stream on its end ({{bug(1231414)}}).</li>
 <li>The {{domxref("MediaDeviceInfo.groupId")}} property is now implemented ({{bug(1213453)}}). While it has existed in Firefox since Firefox 39, it did not actually gather related devices together into the same group IDs.</li>
 <li>The {{domxref("RTCIceCandidate.usernameFragment")}} property is now implemented ({{bug(1490658)}}).</li>
 <li><a href="/en-US/docs/Web/API/WebVTT_API">WebVTT</a> has been revised to correctly use <code>auto</code> as the default for the {{domxref("VTTCue")}} object's {{domxref("VTTCue.positionAlign", "positionAlign")}} property, instead of <code>center</code>. This causes the cue box's alignment to correspond to the alignment of the text within it ({{bug(1528420)}}).</li>
</ul>

<h4 id="Canvas_and_WebGL">Canvas and WebGL</h4>

<ul>
 <li>The <code><a href="/en-US/docs/Web/API/EXT_float_blend">EXT_float_blend</a></code> WebGL extension has been enabled by default ({{bug(1535808)}}).</li>
</ul>

<h4 id="Removals_3">Removals</h4>

<ul>
 <li>The deprecated <code>ShadowRoot.getElementsByTagName</code>, <code>ShadowRoot.getElementsByTagNameNS</code>, and <code>ShadowRoot.getElementsByClassName</code> properties (part of Shadow DOM v0) have been removed ({{bug(1535438)}}).</li>
 <li><code><a href="/en-US/docs/Web/API/Document/createEvent">document.createEvent("TouchEvent")</a></code>, {{domxref("document.createTouch()")}}, {{domxref("document.createTouchList()")}}, and the <code>ontouch*</code> event handler properties have been disabled on desktop to improve web compatibility on websites where touch support is used for mobile detection ({{bug(1412485)}}). In such cases, websites have been seen to behave incorrectly or unexpectedly on touchscreen laptops.</li>
</ul>

<h3 id="Security">Security</h3>

<ul>
 <li><a href="/en-US/docs/Web/API/Notifications_API">Notifications</a> are now only available in a <a href="/en-US/docs/Web/Security/Secure_Contexts">secure context</a> ({{bug(1429432)}}).</li>
 <li>Firefox now blocks the loading of external protocol URLs in {{htmlelement("iframe")}}s ({{bug(1527882)}}).</li>
</ul>

<h3 id="WebDriver_conformance_Marionette">WebDriver conformance (Marionette)</h3>

<h4 id="API_changes">API changes</h4>

<ul>
 <li>Made <code>WebDriver:SendAlertText</code> conformant to the <a href="https://w3c.github.io/webdriver/">WebDriver specification</a> ({{bug(1502360)}}).</li>
</ul>

<h4 id="Bug_fixes">Bug fixes</h4>

<ul>
 <li><code>WebDriver:NewWindow</code> will no longer timeout because of <code>focus</code>-related inconsistencies across platforms ({{bug(1523234)}}).</li>
</ul>

<h4 id="Others">Others</h4>

<ul>
 <li>Both <code>WebDriver:ExecuteScript</code> and <code>WebDriver:ExecuteAsyncScript</code> now use <code>Promises</code> internally ({{bug(1398095)}}).</li>
 <li><code>WebDriver:NewSession</code> returns Firefox's <code>BuildID</code> string as part of the capabilities object ({{bug(1525829)}}).</li>
</ul>

<h2 id="Changes_for_add-on_developers">Changes for add-on developers</h2>

<h3 id="API_changes_2">API changes</h3>

<ul>
 <li>Using the <code>proxy.settings.set()</code> method to change <code>{{WebExtAPIRef("types.BrowserSetting", "BrowserSetting")}}</code> values will throw an exception unless the extension was granted private window access by the user ({{bug(1525447)}}).</li>
</ul>

<h3 id="Manifest_changes">Manifest changes</h3>

<ul>
 <li>A new manifest key, <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/manifest.json/incognito">incognito</a>, defines the behavior of an extension in private browsing windows or tabs ({{bug(1511636)}}).</li>
 <li>The <code>toolbar_field_highlight</code> setting controls the background color used to indicate the current selection of text in the URL bar ({{bug(1450114)}}).</li>
 <li>The <code>toolbar_field_highlight_text</code> setting controls the text color used to indicate the current selection of text in the URL bar ({{bug(1450114)}}).</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>Hacks release post: <a href="https://hacks.mozilla.org/2019/05/firefox-67-dark-mode-css-webrender/">Firefox 67: Dark Mode CSS, WebRender, and more</a></li>
 <li><a href="https://www.fxsitecompat.com/en-CA/versions/67/">Site compatibility for Firefox 67</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(66)}}</p>
